﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace LockCrypt.Core {
    public class NullEncryptionService :EncryptionBase {
        public override EncryptionProviders EncryptionAlgorithm {
            get { return EncryptionProviders.None; }
        }

        public override byte[] Encrypt(byte[] input) {
            return input;
        }

        public override byte[] Decrypt(byte[] input) {
            return input;
        }

        public override byte[] EncryptString(string input) {
            if(input == null) return null;
            return Encoding.UTF8.GetBytes(input);
        }

        public override string DecryptString(byte[] input) {
            if(input == null) return null;
            return Encoding.UTF8.GetString(input);
        }
    }
}
