﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LockCrypt.DAL {
    /// <summary>
    /// A database which uses a file as a backing store.
    /// </summary>
    public abstract class FileBasedDatabase {
        protected string _filename;

        /// <summary>
        /// Gets or sets the filename of the database.
        /// </summary>
        /// <value>The filename of the database.</value>
        public string FileName {
            get { return _filename; }
            set { _filename = value; }
        }

        /// <summary>
        /// Initializes a new <see cref="FileBasedDatabase"/>.
        /// </summary>
        /// <param name="fileName">Name of the database file.</param>
        protected FileBasedDatabase(string fileName) {
            _filename = fileName;
        }
    }
}
