﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Diagnostics;
using LockCrypt.Core;

namespace LockCrypt {
    /// <summary>
    /// The 'About LockCrypt' window.
    /// </summary>
    public partial class WinAbout : Window {
        public WinAbout() {
            InitializeComponent();
        }

        /// <summary>
        /// Sets the version and build date text when the window loads.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        private void Window_Loaded(object sender, RoutedEventArgs e) {
            lblVersion.Text = Constants.GetVersion().ToString();
            lblDate.Text = Constants.BuildDate.ToUniversalTime().ToString("d/MM/yyyy HH:mm") + " UTC";
        }

        /// <summary>
        /// Opens a URL.
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The <see cref="System.Windows.Navigation.RequestNavigateEventArgs"/> instance containing the event data.</param>
        private void OpenURL(object sender, System.Windows.Navigation.RequestNavigateEventArgs e) {
            string url = e.Uri.ToString();
            if(url.Length > 0) {
                Process.Start(url);
            }
        }

        /// <summary>
        /// Shows a photo of ME when the user clicks "Harry Jennerway" and holds shift, ctrl or alt.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Input.MouseEventArgs"/> instance containing the event data.</param>
        private void hjennerway_MouseDown(object sender, MouseEventArgs e) {
            if(Keyboard.Modifiers != ModifierKeys.None) {
                imgLogo.Source = new BitmapImage(new Uri("pack://application:,,,/Resources/images/hjennerway_cigar.png", UriKind.Absolute));
            }
        }
    }
}
